#include <avr/io.h>
#include <util/delay.h>

#define DDR_SPI DDRB
#define DD_MOSI PB3
#define DD_MISO PB4
#define DD_SCK PB5
#define DD_SS PB2


static int index = 0;
static int arIndex = 0;
static byte data[255];
static byte ar1[5];
static byte ar2[5];
static byte ar3[5];



void SPI_SlaveInit(void)
{
    DDR_SPI = (1 << DD_MISO);

    SPCR = (1 << SPE) | (1 << SPIE);
}

ISR(SPI_STC_vect)
{
    char received = SPDR;
    data[index] = received;
    index++;
}

void setup()
{
    Serial.begin(2000000);
    SPI_SlaveInit();
    Serial.println();
    Serial.println("Initialization ");
}

void SetCommand(byte *data2){
    byte command = data2[0];
    // Отрезать 1 элемент от оставшихся
    byte result[index];
    byte *ptr = &data2[1];
    strcpy(result, ptr);
    Serial.print("\nReceived command: ");
    Serial.println(command);
    switch (command){
        case 6:
            AddSymbol(result);
            break;

    }
}


void AddSymbol(byte *symbols){
    Serial.print("Received Add: ");

    for(int i = 0; i < index - 1; i++) {
        Serial.print(symbols[i]);
        Serial.print(" ");
    }
}


// Функция для вычисления контрольной суммы XOR
byte calculateXORChecksum(byte *data, int length) {
    byte checksum = 0;
    for (int i = 0; i < length - 1; i++) {
        checksum ^= data[i];
    }
    return checksum;
}

void arrayOut(byte *arr,int size){
  Serial.print("Array: ");
  for(int i = 0;i<size;i++){
    Serial.print(arr[i]);
    Serial.print(" ");
  }
  Serial.println(".");
}

void loop() {
  if(PINB & (1 << 2))
  {
    if(index > 0)
    {
      // byte calculatedChecksum = calculateXORChecksum(data, index-1);
      // byte last = data[index - 1];
      // Serial.println();
      // Serial.println("--------------");
      // Serial.print("\n Last: ");
      // Serial.print(last);
      // Serial.print("\t Sum: ");
      // Serial.println(calculatedChecksum);
      
      
      // if (last != calculatedChecksum)
      // {
      //   Serial.println("\n -----Invalid Checksum!---");
      //   SPDR = calculatedChecksum;
      //   index = 0;
      //   return;
      // }
      
      //SetCommand(data);
      if (arIndex == 0){
        arIndex = 1;
        memcpy(ar1,data,5);
      }else{
        if(arIndex == 1){
          arIndex = 2;
          memcpy(ar2,data,5);
        }else{
          arIndex = 0;
          memcpy(ar3,data,5);
        }
      }
      byte sum = 0;
      Serial.println();
      Serial.println("Старт вывода массивов");
      arrayOut(ar1,5);
      sum = calculateXORChecksum(ar1,5);
      Serial.println(sum);
      arrayOut(ar2,5);
      sum = calculateXORChecksum(ar2,5);
      Serial.println(sum);
      arrayOut(ar3,5);
      sum = calculateXORChecksum(ar3,5);
      Serial.println(sum);
      Serial.println("Стоп вывода массивов");
      index=0;
    }
  }
}
